﻿using UnityEngine;
using System.Collections;

public class RaycastingScript : MonoBehaviour {

	private Interactable interactable;
	private Interactable prevInteractable;

	// Update is called once per frame
	void Update () {
		Ray ray = new Ray(transform.position, transform.forward);
		RaycastHit hit;
		if (Physics.Raycast(ray, out hit, 3)) {
			interactable = hit.transform.GetComponent<Interactable>();
			if (interactable != null) {
				if (prevInteractable != interactable) {
					if (prevInteractable != null) prevInteractable.OnStopWatching();
					interactable.OnStartWatching();
				}
				interactable.OnWatch();
				if (Input.GetKeyDown(KeyCode.E)) interactable.Interact();
				prevInteractable = interactable;
			} else if (prevInteractable != null) {
				prevInteractable.OnStopWatching();
				prevInteractable = null;
			}
		} else if (prevInteractable != null) {
			prevInteractable.OnStopWatching();
			prevInteractable = null;
		}
	}
}
